package com.tztzf.network.cosign;

import static com.tztzf.network.cosign.tztZFCosignErr.tztZFCosignErrCertDeviceDel;
import static com.tztzf.network.cosign.tztZFCosignErr.tztZFCosignErrCertMax;
import static com.tztzf.network.cosign.tztZFCosignErr.tztZFCosignErrClientSign0;
import static com.tztzf.network.cosign.tztZFCosignErr.tztZFCosignErrClientSign1;
import static com.tztzf.network.cosign.tztZFCosignErr.tztZFCosignErrClientSign2;
import static com.tztzf.network.cosign.tztZFCosignErr.tztZFCosignErrConnect;
import static com.tztzf.network.cosign.tztZFCosignErr.tztZFCosignErrCreateP10;
import static com.tztzf.network.cosign.tztZFCosignErr.tztZFCosignErrDevice;
import static com.tztzf.network.cosign.tztZFCosignErr.tztZFCosignErrExpire;
import static com.tztzf.network.cosign.tztZFCosignErr.tztZFCosignErrOK;
import static com.tztzf.network.cosign.tztZFCosignErr.tztZFCosignErrOther;
import static com.tztzf.network.cosign.tztZFCosignErr.tztZFCosignErrParam;
import static com.tztzf.network.cosign.tztZFCosignErr.tztZFCosignErrPin;
import static com.tztzf.network.cosign.tztZFCosignErr.tztZFCosignErrServerCertUnfind;
import static com.tztzf.network.cosign.tztZFCosignErr.tztZFCosignErrSign;
import static com.tztzf.network.cosign.tztZFCosignErr.tztZFCosignErrUnfind;

import com.tztzf.baseos.tztZFIntDef;

import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

@tztZFIntDef({
        tztZFCosignErrOK,
        tztZFCosignErrConnect,
        tztZFCosignErrPin,
        tztZFCosignErrUnfind,
        tztZFCosignErrDevice,
        tztZFCosignErrExpire,
        tztZFCosignErrParam,
        tztZFCosignErrCreateP10,
        tztZFCosignErrClientSign0,
        tztZFCosignErrClientSign1,
        tztZFCosignErrClientSign2,
        tztZFCosignErrSign,
        tztZFCosignErrOther,
        tztZFCosignErrCertMax,
        tztZFCosignErrServerCertUnfind,
        tztZFCosignErrCertDeviceDel
})

@Retention(RetentionPolicy.SOURCE)
public @interface tztZFCosignErr {
    /** 成功 */
    int tztZFCosignErrOK = 1;
    /** 网络错误 */
    int tztZFCosignErrConnect = -1;
    /** 国密降级 */
    int tztZFCosignErrDowngrade = -2;
    /** Pin错误 */
    int tztZFCosignErrPin = -10;
    /** 未加载证书 */
    int tztZFCosignErrNoLoad = -11;
    /** 未找到 */
    int tztZFCosignErrUnfind = -20;
    /** 设备信息错误 */
    int tztZFCosignErrDevice = -21;
    /** 证书过期(失效) */
    int tztZFCosignErrExpire = -22;
    /** 参数错误 */
    int tztZFCosignErrParam = -31;
    /** 客户端签名错误 */
    int tztZFCosignErrCreateP10 = -40;
    int tztZFCosignErrClientSign0 = -41;
    int tztZFCosignErrClientSign1 = -42;
    int tztZFCosignErrClientSign2 = -43;
    /** 签名错误 */
    int tztZFCosignErrSign = -51;
    /** 其他错误 */
    int tztZFCosignErrOther = -99;
    /** 证书申请超限 */
    int tztZFCosignErrCertMax = -98977004;
    /** 获取服务端密钥分量数据有误，无对应记录，重新申请； */
    int tztZFCosignErrServerCertUnfind = -98975103;
    /** 地证书在其他设备上删除 */
    int tztZFCosignErrCertDeviceDel = -98977303;
}
