package com.tztzf.network.cosign;

import com.tztzf.base.tztZFPublicFun;
import com.tztzf.baseos.tztZFTextUtils;
import com.tztzf.commbase.tztZFDataMapBase;
import com.tztzf.commbase.tztZFDataMapCallBack;
import com.tztzf.network.tztZFNetWorkReqObj;

import java.util.ArrayList;

class tztZFDataMapBase_AddToReq {

    public static void addToReqObj(final tztZFDataMapBase<String, Object> dataMap, final tztZFNetWorkReqObj reqObj) {
        if (dataMap != null && reqObj != null) {
            dataMap.enumerateKeysAndObjectsUsingBlock(new tztZFDataMapCallBack() {
                @Override
                public boolean enumerate(String lowKey, String key, Object value) {
                    boolean bAdd = true;
                    if (value instanceof String) {
                        reqObj.setStr(key, (String) value);
                    } else if (value instanceof byte[]) {
                        reqObj.setBytes(key, (byte[]) value);
                    } else if (value instanceof tztZFDataMapBase) {
                        reqObj.setDataMap(key, (tztZFDataMapBase) value);
                    } else {
                        String str = tztZFDataMapBase.getStringUsingEncoding(value, dataMap.getEncodeType());
                        if (tztZFTextUtils.isEmpty(str)) {
                            bAdd = false;
                        } else {
                            reqObj.setStr(key, str);
                        }
                    }
                    return false;
                }
            });
        }
    }

    public static ArrayList<ArrayList<String>> getArray(final tztZFDataMapBase<String, Object> dataMap, String key) {
        if (dataMap == null)
            return null;
        String value = dataMap.getStr(key);
        if (tztZFTextUtils.isEmpty(value))
            return null;
        try {
            ArrayList<ArrayList<String>> ayValues = new ArrayList<>();

            ArrayList<String> ayGrid = new ArrayList<>();
            tztZFPublicFun.split(value, "\r\n", ayGrid);
            for (String strValue : ayGrid) {
                if (strValue.length() < 1)
                    continue;
                ArrayList<String> ayData = new ArrayList<>();
                tztZFPublicFun.split(strValue, "|", ayData);
                if (ayData.size() < 1)
                    continue;
                ayValues.add(ayData);
            }
            return ayValues;
        } catch (Exception ex) {
        }
        return null;
    }


}
