package com.tztzf.network.cosign;

import com.tztzf.tztZFPrivate;

import java.io.ByteArrayOutputStream;

@tztZFPrivate(name = "内部类，外层禁止调用")
public class tztZFInputStream {
    private ByteArrayOutputStream destData;

    public tztZFInputStream() {
        destData = new ByteArrayOutputStream();
    }

    public void appendByte(byte[] byteData) {
        if (byteData == null || byteData.length < 1)
            return;
        destData.write(byteData, 0, byteData.length);
    }

    public void appendStr(String str) {
        if (str == null || str.length() < 1)
            return;
        byte[] vData = str.getBytes();
        appendByte(vData);
    }


    public void appendLenStr(String str) {
        byte[] vData = null;
        if (str != null && str.length() > 0) {
            vData = str.getBytes();
        }
        appendLenByte(vData);
    }

    public void appendLenByte(byte[] byteData) {
        int len = 0;
        if (byteData != null) {
            len = Math.max(0, byteData.length);
        }
        appendInt(len);
        if (len > 0) {
            appendByte(byteData);
        }
    }


    /**
     * int值转byte数组，低位在前
     * @param value int数据
     * @return 转换后的byte数组
     */
    private static byte[] intToByteArray(int value) {
        return new byte[]{
                (byte) (value & 0xFF),
                (byte) ((value >> 8) & 0xFF),
                (byte) ((value >> 16) & 0xFF),
                (byte) ((value >> 24) & 0xFF)
        };
    }


    public void appendInt(int nVal) {
        byte[] bytes = intToByteArray(nVal);
        appendByte(bytes);
    }

    public byte[] getInputData() {
        return destData.toByteArray();
    }
}
