package com.tztzf.network.cosign;

import com.tztzf.commbase.tztZFDataMapBase;
import com.tztzf.network.tztZFNetWorkRespObj;

import java.util.ArrayList;
import java.util.Arrays;

public class tztZFNetCosignHead {
    /**
     * 通用应答
     */
    public static class tztZFCosignResp {
        /** 错误号 */
        @tztZFCosignErr
        protected int errorNO;
        /** 错误信息 */
        protected String errorMessage;
        /** 签名类型 0-中焯 1-智慧 */
        protected int cosignType;
        /** 国密状态 =true 表示降级处理 */
        private boolean cosignDowngrade;
        /** 业务来源：0-通讯 1-上层业务调用 */
        private int fromType;

        /** 扩展数据 */
        tztZFDataMapBase<String, Object> dictExtern = new tztZFDataMapBase<>();

        public int getErrorNO() {
            return errorNO;
        }

        public void setErrorNO(int errorNO) {
            this.errorNO = errorNO;
        }

        public String getErrorMessage() {
            return errorMessage;
        }

        public void setErrorMessage(String errorMessage) {
            this.errorMessage = errorMessage;
        }

        public int getCosignType() {
            return cosignType;
        }

        public void setCosignType(int cosignType) {
            this.cosignType = cosignType;
        }

        public boolean isCosignDowngrade() {
            return cosignDowngrade;
        }

        public void setCosignDowngrade(boolean cosignDowngrade) {
            this.cosignDowngrade = cosignDowngrade;
        }

        public int getFromType() {
            return fromType;
        }

        public void setFromType(int fromType) {
            this.fromType = fromType;
        }

        public tztZFDataMapBase<String, Object> getDictExtern() {
            return dictExtern;
        }

        public void setDictExtern(tztZFDataMapBase<String, Object> dictExtern) {
            this.dictExtern = dictExtern;
        }

        @Override
        public String toString() {
            return "tztZFCosignResp{" +
                    "errorNO=" + errorNO +
                    ", errorMessage='" + errorMessage + '\'' +
                    ", cosignType=" + cosignType +
                    ", cosignDowngrade=" + cosignDowngrade +
                    ", fromType=" + fromType +
                    ", dictExtern=" + dictExtern.toString() +
                    '}';
        }
    }

    /**
     * 协同签名应答
     */
    public static class tztZFNetCosignResp {
        /** 错误号 */
        @tztZFCosignErr
        int errorNO;
        /** 错误信息 */
        String errorMessage;
        /** 客户号 */
        String userID;
        /** 客户token */
        String userToken;
        /** 国密状态，=true,表示降级处理 */
        boolean cosignDowngrade;
        /** 报错数据是否为app层报错，非服务端报错 */
        boolean bLocalError;
        /** 扩展数据 */
        tztZFDataMapBase<String, Object> dictExtern = new tztZFDataMapBase<>();

        public int getErrorNO() {
            return errorNO;
        }

        public void setErrorNO(int errorNO) {
            this.errorNO = errorNO;
        }

        public String getErrorMessage() {
            return errorMessage;
        }

        public void setErrorMessage(String errorMessage) {
            this.errorMessage = errorMessage;
        }

        public String getUserID() {
            return userID;
        }

        public void setUserID(String userID) {
            this.userID = userID;
        }

        public String getUserToken() {
            return userToken;
        }

        public void setUserToken(String userToken) {
            this.userToken = userToken;
        }

        public boolean isCosignDowngrade() {
            return cosignDowngrade;
        }

        public void setCosignDowngrade(boolean cosignDowngrade) {
            this.cosignDowngrade = cosignDowngrade;
        }

        public tztZFDataMapBase<String, Object> getDictExtern() {
            return dictExtern;
        }

        public void setDictExtern(tztZFDataMapBase<String, Object> dictExtern) {
            this.dictExtern = dictExtern;
        }

        public boolean isLocalError() {
            return bLocalError;
        }

        public void setLocalError(boolean bLocalError) {
            this.bLocalError = bLocalError;
        }

        @Override
        public String toString() {
            return "tztZFNetCosignResp{" +
                    "errorNO=" + errorNO +
                    ", errorMessage='" + errorMessage + '\'' +
                    ", userID='" + userID + '\'' +
                    ", userToken='" + userToken + '\'' +
                    ", cosignDowngrade=" + cosignDowngrade +
                    ", dictExtern=" + dictExtern.toString() +
                    '}';
        }
    }

    /**
     * 证书列表
     */
    public static class tztZFNetCosignRespCertList extends tztZFNetCosignResp {
        /** 证书列表 */
        private ArrayList<tztZFCertificateInfo> certList;
        /** 应答信息 */
        private tztZFNetWorkRespObj respObj;

        public ArrayList<tztZFCertificateInfo> getCertList() {
            return certList;
        }

        public void setCertList(ArrayList<tztZFCertificateInfo> certList) {
            this.certList = certList;
        }

        public tztZFNetWorkRespObj getRespObj() {
            return respObj;
        }

        public void setRespObj(tztZFNetWorkRespObj respObj) {
            this.respObj = respObj;
        }

        @Override
        public String toString() {
            return "tztZFNetCosignRespCertList{" +
                    "errorNO=" + errorNO +
                    ", errorMessage='" + errorMessage + '\'' +
                    ", userID='" + userID + '\'' +
                    ", userToken='" + userToken + '\'' +
                    ", cosignDowngrade=" + cosignDowngrade +
                    ", certList=" + certList +
                    '}';
        }
    }

    /**
     * 证书
     */
    public static class tztZFNetCosignRespCert extends tztZFNetCosignResp {
        /** 证书 */
        private tztZFCertificateInfo certInfo;

        public tztZFCertificateInfo getCert() {
            return certInfo;
        }

        public void setCert(tztZFCertificateInfo certInfo) {
            this.certInfo = certInfo;
        }

        @Override
        public String toString() {
            return "tztZFNetCosignRespCert{" +
                    "errorNO=" + errorNO +
                    ", errorMessage='" + errorMessage + '\'' +
                    ", userID='" + userID + '\'' +
                    ", userToken='" + userToken + '\'' +
                    ", cosignDowngrade=" + cosignDowngrade +
                    ", certInfo=" + certInfo +
                    '}';
        }
    }

    /**
     * 证书申请
     */
    public static class tztZFNetCosignRespApplyCert extends tztZFNetCosignResp {
        /** 用户姓名 */
        private String userName;
        /** 设备ID */
        private String deviceID;
        /** 设备信息 */
        private String deviceInfo;
        /** 签名证书序列号 */
        private String certSerialNumber;
        /** 签名证书内容(没有头尾) */
        private String certSignBuf;
        /** 证书有效起始日期 */
        private String certNotBefore;
        /** 证书有效结束日期 */
        private String certNotAfter;
        /** 证书状态 */
        private String certStatus;
        /** 签发日期 */
        private String certSignDate;
        /** 使用者DN */
        private String certSubjectDN;
        /** 加密证书序号 */
        private String certSerialNumberKmc;
        /** 加密证书内容，使用GM加密 */
        private byte[] certSignBufKmc;
        /** 加密的加密证书私钥，使用GM加密 */
        private byte[] encPrivateKeyUser;
        /** 证书类型 */
        private int certType;

        //region get/set

        public String getUserName() {
            return userName;
        }

        public void setUserName(String userName) {
            this.userName = userName;
        }

        public String getDeviceID() {
            return deviceID;
        }

        public void setDeviceID(String deviceID) {
            this.deviceID = deviceID;
        }

        public String getDeviceInfo() {
            return deviceInfo;
        }

        public void setDeviceInfo(String deviceInfo) {
            this.deviceInfo = deviceInfo;
        }

        public String getCertSerialNumber() {
            return certSerialNumber;
        }

        public void setCertSerialNumber(String certSerialNumber) {
            this.certSerialNumber = certSerialNumber;
        }

        public String getCertSignBuf() {
            return certSignBuf;
        }

        public void setCertSignBuf(String certSignBuf) {
            this.certSignBuf = certSignBuf;
        }

        public String getCertNotBefore() {
            return certNotBefore;
        }

        public void setCertNotBefore(String certNotBefore) {
            this.certNotBefore = certNotBefore;
        }

        public String getCertNotAfter() {
            return certNotAfter;
        }

        public void setCertNotAfter(String certNotAfter) {
            this.certNotAfter = certNotAfter;
        }

        public String getCertStatus() {
            return certStatus;
        }

        public void setCertStatus(String certStatus) {
            this.certStatus = certStatus;
        }

        public String getCertSignDate() {
            return certSignDate;
        }

        public void setCertSignDate(String certSignDate) {
            this.certSignDate = certSignDate;
        }

        public String getCertSubjectDN() {
            return certSubjectDN;
        }

        public void setCertSubjectDN(String certSubjectDN) {
            this.certSubjectDN = certSubjectDN;
        }

        public String getCertSerialNumberKmc() {
            return certSerialNumberKmc;
        }

        public void setCertSerialNumberKmc(String certSerialNumberKmc) {
            this.certSerialNumberKmc = certSerialNumberKmc;
        }

        public byte[] getCertSignBufKmc() {
            return certSignBufKmc;
        }

        public void setCertSignBufKmc(byte[] certSignBufKmc) {
            this.certSignBufKmc = certSignBufKmc;
        }

        public byte[] getEncPrivateKeyUser() {
            return encPrivateKeyUser;
        }

        public void setEncPrivateKeyUser(byte[] encPrivateKeyUser) {
            this.encPrivateKeyUser = encPrivateKeyUser;
        }

        public int getCertType() {
            return certType;
        }

        public void setCertType(int certType) {
            this.certType = certType;
        }

        @Override
        public String toString() {
            return "tztZFNetCosignRespApplyCert{" +
                    "errorNO=" + errorNO +
                    ", errorMessage='" + errorMessage + '\'' +
                    ", userID='" + userID + '\'' +
                    ", userToken='" + userToken + '\'' +
                    ", cosignDowngrade=" + cosignDowngrade +
                    ", userName='" + userName + '\'' +
                    ", deviceID='" + deviceID + '\'' +
                    ", deviceInfo='" + deviceInfo + '\'' +
                    ", certSerialNumber='" + certSerialNumber + '\'' +
                    ", certSignBuf='" + certSignBuf + '\'' +
                    ", certNotBefore='" + certNotBefore + '\'' +
                    ", certNotAfter='" + certNotAfter + '\'' +
                    ", certStatus='" + certStatus + '\'' +
                    ", certSignDate='" + certSignDate + '\'' +
                    ", certSubjectDN='" + certSubjectDN + '\'' +
                    ", certSerialNumberKmc='" + certSerialNumberKmc + '\'' +
                    ", certSignBufKmc=" + Arrays.toString(certSignBufKmc) +
                    ", encPrivateKeyUser=" + Arrays.toString(encPrivateKeyUser) +
                    ", certType=" + certType +
                    '}';
        }

        //endregion
    }


    /**
     * 协同签名初始化
     */
    public static class tztZFNetCosignRespCosignInit extends tztZFNetCosignResp {
        private byte[] P;
        private int isNew;
        private byte[] D;
        private byte[] P1;
        private String DMark;

        public byte[] getP() {
            return P;
        }

        public void setP(byte[] p) {
            P = p;
        }

        public int getIsNew() {
            return isNew;
        }

        public void setIsNew(int isNew) {
            this.isNew = isNew;
        }

        public byte[] getD() {
            return D;
        }

        public void setD(byte[] d) {
            D = d;
        }

        public byte[] getP1() {
            return P1;
        }

        public void setP1(byte[] p1) {
            P1 = p1;
        }

        public String getDMark() {
            return DMark;
        }

        public void setDMark(String DMark) {
            this.DMark = DMark;
        }

        @Override
        public String toString() {
            return "tztZFNetCosignRespCosignInit{" +
                    "errorNO=" + errorNO +
                    ", errorMessage='" + errorMessage + '\'' +
                    ", userID='" + userID + '\'' +
                    ", userToken='" + userToken + '\'' +
                    ", cosignDowngrade=" + cosignDowngrade +
                    ", P=" + Arrays.toString(P) +
                    ", isNew=" + isNew +
                    ", D=" + Arrays.toString(D) +
                    ", P1=" + Arrays.toString(P1) +
                    ", DMark=" + (DMark != null ? DMark : "null") +
                    '}';
        }
    }


    /**
     * 协同签名
     */
    public static class tztZFNetCosignRespCosignData extends tztZFNetCosignResp {
        private String signUser;
        private byte[] signData;

        public String getSignUser() {
            return signUser;
        }

        public void setSignUser(String signUser) {
            this.signUser = signUser;
        }

        public byte[] getSignData() {
            return signData;
        }

        public void setSignData(byte[] signData) {
            this.signData = signData;
        }

        @Override
        public String toString() {
            return "tztZFNetCosignRespCosignData{" +
                    "errorNO=" + errorNO +
                    ", errorMessage='" + errorMessage + '\'' +
                    ", userID='" + userID + '\'' +
                    ", userToken='" + userToken + '\'' +
                    ", cosignDowngrade=" + cosignDowngrade +
                    ", signUser='" + signUser + '\'' +
                    ", signData=" + Arrays.toString(signData) +
                    '}';
        }
    }

    /**
     * 协同数据接口回调
     */
    public interface tztZFNetCosignCallBack {
        void callBack(boolean c_bOK, tztZFDataMapBase<String, Object> c_cosign);
    }

    public interface tztZFCosignResponse {
        void callBack(String userID, tztZFCosignResp resp);
    }

    public interface tztZFNetCosignRespCertListCallBack {
        void onCallBack(tztZFNetCosignHead.tztZFNetCosignRespCertList c_resp);
    }

    public interface tztZFNetCosignRespCertCallBack {
        void onCallBack(tztZFNetCosignHead.tztZFNetCosignRespCert c_resp);
    }

    public interface tztZFNetCosignRespApplyCertCallBack {
        void onCallBack(tztZFNetCosignHead.tztZFNetCosignRespApplyCert c_resp);
    }

    public interface tztZFNetCosignRespCallBack {
        void onCallBack(tztZFNetCosignHead.tztZFNetCosignResp c_resp);
    }

    public interface tztZFNetCosignRespCosignInitCallBack {
        void onCallBack(tztZFNetCosignHead.tztZFNetCosignRespCosignInit c_resp);
    }

    public interface tztZFNetCosignRespCosignDataCallBack {
        void onCallBack(tztZFNetCosignHead.tztZFNetCosignRespCosignData c_resp);
    }

    public interface tztZFNetCosignResetRespCallBack {
        void onCallBack(byte[] P1, tztZFNetCosignResp c_resp);
    }
}