package com.tztzf.network.define;

import static com.tztzf.network.define.tztZFSocketFlags.tztZFSocketFlags_ConnFail;
import static com.tztzf.network.define.tztZFSocketFlags.tztZFSocketFlags_ConnSucess;
import static com.tztzf.network.define.tztZFSocketFlags.tztZFSocketFlags_Connect;
import static com.tztzf.network.define.tztZFSocketFlags.tztZFSocketFlags_Conning;
import static com.tztzf.network.define.tztZFSocketFlags.tztZFSocketFlags_DisConning;
import static com.tztzf.network.define.tztZFSocketFlags.tztZFSocketFlags_End;
import static com.tztzf.network.define.tztZFSocketFlags.tztZFSocketFlags_Init;
import static com.tztzf.network.define.tztZFSocketFlags.tztZFSocketFlags_No;

import com.tztzf.baseos.tztZFIntDef;
import com.tztzf.network.gm.tztZFSocketSSLStep;

import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.util.Locale;

/**
 * ****************************************************************
 * 文件名称 : tztZFSocketFlags
 * 作   者 : Created by yangdl
 * 创建时间 : 2021-03-09 14:11
 * 文件描述 :
 * 注意事项 :
 * 版权声明 : Copyright (C) 2021-2030 杭州中焯信息技术股份有限公司
 * 修改历史 : 2021-03-09 1.00 初始版本
 * ****************************************************************
 */

@tztZFIntDef({
        tztZFSocketFlags_No,
        tztZFSocketFlags_Init,
        tztZFSocketFlags_Conning,
        tztZFSocketFlags_ConnSucess,
        tztZFSocketFlags_ConnFail,
        tztZFSocketFlags_End,
        tztZFSocketFlags_DisConning,
        tztZFSocketFlags_Connect
})

@Retention(RetentionPolicy.SOURCE)
public @interface tztZFSocketFlags {
    //region 内部私有属性及函数
    /** 不再连接服务器 */
    int tztZFSocketFlags_No = (0);
    /** 服务器初始状态 */
    int tztZFSocketFlags_Init = (1);
    /** 正在连接服务器 */
    int tztZFSocketFlags_Conning = (2);
    /** 服务器连接成功 */
    int tztZFSocketFlags_ConnSucess = (3);
    /** 服务器连接失败 */
    int tztZFSocketFlags_ConnFail = (4);
    /** 服务结束 */
    int tztZFSocketFlags_End = (5);
    /** 服务器正在断开 */
    int tztZFSocketFlags_DisConning = (6);
    /** 服务器连接成功 */
    int tztZFSocketFlags_Connect = (7);
    //endregion

    class tztZFSocketFlagTip {
        public static String tips(@tztZFSocketSSLStep int step) {
            switch (step) {
                case tztZFSocketFlags_No:
                    return "tztZFSocketFlags_No";
                case tztZFSocketFlags_Init:
                    return "tztZFSocketFlags_Init";
                case tztZFSocketFlags_Conning:
                    return "tztZFSocketFlags_Conning";
                case tztZFSocketFlags_ConnSucess:
                    return "tztZFSocketFlags_ConnSucess";
                case tztZFSocketFlags_ConnFail:
                    return "tztZFSocketFlags_ConnFail";
                case tztZFSocketFlags_End:
                    return "tztZFSocketFlags_End";
                case tztZFSocketFlags_DisConning:
                    return "tztZFSocketFlags_DisConning";
                case tztZFSocketFlags_Connect:
                    return "tztZFSocketFlags_Connect";
                default:
                    return String.format(Locale.getDefault(), "tztZFSocketFlags_Invaild_%d", step);
            }
        }
    }

}
