package com.tztzf.network.socket.Netty;

import com.tztzf.base.tztZFPublicFun;

/**
 * ****************************************************************
 * 文件名称 : tztZFHostport
 * 作   者 : Created by yangdl
 * 创建时间 : 20221206
 * 文件描述 : 地址
 * 注意事项 :
 * 版权声明 : Copyright (C) 2022-2027 杭州中焯信息技术股份有限公司
 * 修改历史 : 20221206 1.00 初始版本
 * ****************************************************************
 */

public class tztZFHostport {
    ///名称
    private String addrname = "";
    private String host = "";
    private int port = 0;
    ///连接类别
    private int connecttype = 0;

    ///address=host:port
    public tztZFHostport(String address) {
        initwithAddress(address, "", 0);
    }

    public tztZFHostport(String address, String addrName, int connecttype) {
        initwithAddress(address, addrName, connecttype);
    }

    private void initwithAddress(String address, String addrName, int connecttype) {
        if (tztZFPublicFun.isEmpty(address))
            return;
        int lastIndex = address.lastIndexOf(":");
        if (lastIndex <= 0)
            return;
        String strHost = address.substring(0, lastIndex);
        String strPort = address.substring(lastIndex + 1);
        if (tztZFPublicFun.isEmpty(strHost) || tztZFPublicFun.isEmpty(strPort))
            return;
        this.addrname = addrName;
        this.host = strHost;
        this.port = tztZFPublicFun.parseInt(strPort, 0);
        this.connecttype = connecttype;
    }

    ///无效
    public boolean isInvalid() {
        if (tztZFPublicFun.isEmpty(host) || port <= 0 || port > 65535)
            return true;
        return false;
    }

    ///有效
    public boolean isValid() {
        return !isInvalid();
    }

    ///host:port
    public String address() {
        if (isInvalid())
            return "";
        return host + ":" + port;
    }

    ///相同
    public boolean isEqualToHostport(tztZFHostport hostport) {
        if (hostport == null)
            return false;
        String strAddress = address();
        String strHostport = hostport.address();
        return strAddress.equalsIgnoreCase(strHostport);
    }

    @Override
    public String toString() {
        return "[" + connecttype + "]" + address();
    }

    public String getAddrname() {
        return addrname;
    }

    public void setAddrname(String addrname) {
        this.addrname = addrname;
    }

    public String getHost() {
        return host;
    }

    public void setHost(String host) {
        this.host = host;
    }

    public int getPort() {
        return port;
    }

    public void setPort(int port) {
        this.port = port;
    }

    public int getConnecttype() {
        return connecttype;
    }

    public void setConnecttype(int connecttype) {
        this.connecttype = connecttype;
    }
}
