package com.tztzf.network.socket.Netty;

import static com.tztzf.network.socket.Netty.tztZFSocketSSLFlag.tztZFSocketSSLFlag_Close;
import static com.tztzf.network.socket.Netty.tztZFSocketSSLFlag.tztZFSocketSSLFlag_Disconnect;
import static com.tztzf.network.socket.Netty.tztZFSocketSSLFlag.tztZFSocketSSLFlag_OKAndTaken;
import static com.tztzf.network.socket.Netty.tztZFSocketSSLFlag.tztZFSocketSSLFlag_Socket;

import com.tztzf.baseos.tztZFIntDef;

import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

/**
 * ****************************************************************
 * 文件名称 : tztZFSocketSSLFlag
 * 作   者 : Created by yangdl
 * 创建时间 : 20221206
 * 文件描述 : socketSSL标识
 * 注意事项 :
 * 版权声明 : Copyright (C) 2022-2027 杭州中焯信息技术股份有限公司
 * 修改历史 : 20221206 1.00 初始版本
 * ****************************************************************
 */

@tztZFIntDef({
        tztZFSocketSSLFlag_Close,
        tztZFSocketSSLFlag_Disconnect,
        tztZFSocketSSLFlag_Socket,
        tztZFSocketSSLFlag_OKAndTaken
})
@Retention(RetentionPolicy.SOURCE)
public @interface tztZFSocketSSLFlag {
    //region 内部私有属性及函数
    //关闭
    int tztZFSocketSSLFlag_Close = (-1);
    //断开
    int tztZFSocketSSLFlag_Disconnect = (0);
    //启用Socket connect
    int tztZFSocketSSLFlag_Socket = (1);
    //启用并已接手
    int tztZFSocketSSLFlag_OKAndTaken = (9);
    //endregion
}
