package com.tztzf.protocol.core;

import com.tztzf.commbase.tztZFDataMapBase;
import com.tztzf.protocol.define.tztZFPackageType;

import static com.tztzf.protocol.define.tztZFPackageType.tztZFPackage_Non;

public final class tztZFRecvPackage {

    private tztZFDataMapBase<String, Object> recvData = null;
    private @tztZFPackageType int packageType = tztZFPackage_Non;
    private int recvTag = -1;
    private int action = 0;

    public tztZFRecvPackage(tztZFDataMapBase<String, Object> recvMap) {
        recvData = recvMap;
    }

    public tztZFDataMapBase<String, Object> getRecvData() {
        return recvData;
    }

    public int getTag() {
        return recvTag;
    }

    public void setRecvTag() {
        if (recvData == null)
            recvTag = -1;
        else {
            recvTag = recvData.getInt("ReqNo", -1);
            action = recvData.getInt("Action", 0);
        }
    }

    public int getAction() {
        return action;
    }

    public @tztZFPackageType int getPackageType() {
        return packageType;
    }

    void setPackageType(@tztZFPackageType int type) {
        packageType = type;
    }

    byte[] getIntacttoServer() {
        if (recvData == null)
            return null;
        return recvData.getBytes("IntactToServer");
    }
}
