package com.tztzf.protocol.core;

import static com.tztzf.protocol.core.tztZFDataEncrypt.encryptBase64Str;
import static com.tztzf.protocol.define.tztZFCertType.tztZFCertPEMFile0;

import com.tztzf.protocol.tztnative.tztNativeBioSSL;

public class tztZFSSLCert {
    private String certUser = "";
    private int certType = 0;
    private byte[] certCA = null;
    private int certCAType = tztZFCertPEMFile0;

    private byte[] certEnc = null;
    private byte[] certEncKey = null;
    private byte[] certEncKeyPass = null;
    private int certEncType = 0;

    private String certSignSN = "";
    private byte[] certSign = null;
    private byte[] certSignKey = null;
    private byte[] certSignKeyPass = null;
    private int certSignType = 0;

    public tztZFSSLCert() {

    }

    ///签名证书有效性校验
    public int verifySign() {
        if (certSign == null || certSign.length < 1)
            return -1;
        return tztNativeBioSSL.ssl_verifyCert(certCAType, certCA, certSignType, certSign);
    }

    ///加密证书有效性校验
    public int verifyEnc() {
        if (certEnc == null || certEnc.length < 1)
            return -1;
        return tztNativeBioSSL.ssl_verifyCert(certCAType, certCA, certEncType, certEnc);
    }

    ///签名证书有效期校验
    public boolean validitySign() {
        if (certSign == null || certSign.length < 1)
            return false;
        return tztNativeBioSSL.ssl_CheckTimeCert(certSignType, certSign);
    }

    ///加密证书有效期校验
    public boolean validityEnc() {
        if (certEnc == null || certEnc.length < 1)
            return false;
        return tztNativeBioSSL.ssl_CheckTimeCert(certEncType, certEnc);
    }

    ///国密签名证书
    public boolean isGMSignCert() {
        if (certSign == null || certSign.length < 1)
            return false;
        return tztNativeBioSSL.ssl_isGMCert(certSignType, certSign);
    }

    public String getCertUser() {
        return certUser;
    }

    public void setCertUser(String certUser) {
        this.certUser = certUser;
    }

    public int getCertType() {
        return certType;
    }

    public void setCertType(int certType) {
        this.certType = certType;
    }

    public byte[] getCertCA() {
        return certCA;
    }

    public void setCertCA(byte[] certCA) {
        this.certCA = certCA;
    }

    public int getCertCAType() {
        return certCAType;
    }

    public void setCertCAType(int certCAType) {
        this.certCAType = certCAType;
    }

    public byte[] getCertEnc() {
        return certEnc;
    }

    public void setCertEnc(byte[] certEnc) {
        this.certEnc = certEnc;
    }

    public byte[] getCertEncKey() {
        return certEncKey;
    }

    public void setCertEncKey(byte[] certEncKey) {
        this.certEncKey = certEncKey;
    }

    public byte[] getCertEncKeyPass() {
        return certEncKeyPass;
    }

    public void setCertEncKeyPass(byte[] certEncKeyPass) {
        this.certEncKeyPass = certEncKeyPass;
    }

    public int getCertEncType() {
        return certEncType;
    }

    public void setCertEncType(int certEncType) {
        this.certEncType = certEncType;
    }

    public String getCertSignSN() {
        return certSignSN;
    }

    public void setCertSignSN(String certSignSN) {
        this.certSignSN = certSignSN;
    }

    public byte[] getCertSign() {
        return certSign;
    }

    public void setCertSign(byte[] certSign) {
        this.certSign = certSign;
    }

    public byte[] getCertSignKey() {
        return certSignKey;
    }

    public void setCertSignKey(byte[] certSignKey) {
        this.certSignKey = certSignKey;
    }

    public byte[] getCertSignKeyPass() {
        return certSignKeyPass;
    }

    public void setCertSignKeyPass(byte[] certSignKeyPass) {
        this.certSignKeyPass = certSignKeyPass;
    }

    public int getCertSignType() {
        return certSignType;
    }

    public void setCertSignType(int certSignType) {
        this.certSignType = certSignType;
    }

    @Override
    public String toString() {
        return "tztZFSSLCert{" +
                "certUser='" + certUser + '\'' +
                ", certType=" + certType +
                ", certCA=" + encryptBase64Str(certCA) +
                ", certCAType=" + certCAType +
                ", certEnc=" + encryptBase64Str(certEnc) +
                ", certEncKey=" + encryptBase64Str(certEncKey) +
                ", certEncKeyPass=" + encryptBase64Str(certEncKeyPass) +
                ", certEncType=" + certEncType +
                ", certSignSN='" + certSignSN + '\'' +
                ", certSign=" + encryptBase64Str(certSign) +
                ", certSignKey=" + encryptBase64Str(certSignKey) +
                ", certSignKeyPass=" + encryptBase64Str(certSignKeyPass) +
                ", certSignType=" + certSignType +
                '}';
    }
}
