package com.tztzf.protocol.define;

import static com.tztzf.protocol.define.tztZFAlgo_EncryptType.tztZFAlgo_EncryptType_AES;
import static com.tztzf.protocol.define.tztZFAlgo_EncryptType.tztZFAlgo_EncryptType_Bus;
import static com.tztzf.protocol.define.tztZFAlgo_EncryptType.tztZFAlgo_EncryptType_RC;
import static com.tztzf.protocol.define.tztZFAlgo_EncryptType.tztZFAlgo_EncryptType_SM;
import static com.tztzf.protocol.define.tztZFAlgo_EncryptType.tztZFAlgo_EncryptType_SM4SM3;

import com.tztzf.baseos.tztZFIntDef;

import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

/**
 * 作者: yangdl 2019.06
 * 用途: 通讯协议分类-同tztZFAlgo_EncryptType
 * 修改记录如下:
 *
 * @版本号: 1.00.001 2019.06.10
 * 更新说明: 第一版正式发布
 */
@tztZFIntDef({
        tztZFAlgo_EncryptType_RC,
        tztZFAlgo_EncryptType_SM,
        tztZFAlgo_EncryptType_AES,
        tztZFAlgo_EncryptType_SM4SM3,
        tztZFAlgo_EncryptType_Bus
})
@Retention(RetentionPolicy.SOURCE)
public @interface tztZFAlgo_EncryptType {
    int tztZFAlgo_EncryptType_RC = (0);     //RC编码
    int tztZFAlgo_EncryptType_SM = (1);     //SM编码
    int tztZFAlgo_EncryptType_AES = (2);    //AES编码
    int tztZFAlgo_EncryptType_SM4SM3 = (4); //SM4-SM3编码
    int tztZFAlgo_EncryptType_Bus = (15);   //自定义编码
}
