package com.tztzf.protocol.define;

import static com.tztzf.protocol.define.tztZFEncryptType.tztZF3DES;
import static com.tztzf.protocol.define.tztZFEncryptType.tztZFAES;
import static com.tztzf.protocol.define.tztZFEncryptType.tztZFBASE64;
import static com.tztzf.protocol.define.tztZFEncryptType.tztZFDES;
import static com.tztzf.protocol.define.tztZFEncryptType.tztZFHEX;
import static com.tztzf.protocol.define.tztZFEncryptType.tztZFMD5File_16;
import static com.tztzf.protocol.define.tztZFEncryptType.tztZFMD5File_32;
import static com.tztzf.protocol.define.tztZFEncryptType.tztZFMD5_16;
import static com.tztzf.protocol.define.tztZFEncryptType.tztZFMD5_32;
import static com.tztzf.protocol.define.tztZFEncryptType.tztZFRC4;
import static com.tztzf.protocol.define.tztZFEncryptType.tztZFRSAPri;
import static com.tztzf.protocol.define.tztZFEncryptType.tztZFRSAPub;
import static com.tztzf.protocol.define.tztZFEncryptType.tztZFRSATempPri;
import static com.tztzf.protocol.define.tztZFEncryptType.tztZFRSATempPub;
import static com.tztzf.protocol.define.tztZFEncryptType.tztZFSHA256;
import static com.tztzf.protocol.define.tztZFEncryptType.tztZFSM2;
import static com.tztzf.protocol.define.tztZFEncryptType.tztZFSM3;
import static com.tztzf.protocol.define.tztZFEncryptType.tztZFSM4;
import static com.tztzf.protocol.define.tztZFEncryptType.tztZFZip;
import static com.tztzf.protocol.define.tztZFEncryptType.tztZFZip_Lz4;
import static com.tztzf.protocol.define.tztZFEncryptType.tztZFZip_Lz4HC;

import com.tztzf.baseos.tztZFIntDef;

import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

/**
 * ****************************************************************
 * 文件名称 : tztZFEncryptType
 * 作   者 : Created by yangares
 * 创建时间 : 2020-06-19 10:13
 * 文件描述 : 加解密类型定义
 * 注意事项 :
 * 版权声明 : Copyright (C) 2015-2025 杭州中焯信息技术股份有限公司
 * 修改历史 : 2020-06-19 1.00 初始版本
 * ****************************************************************
 */
@tztZFIntDef({
        tztZFZip,
        tztZFMD5_16,
        tztZFMD5_32,
        tztZFMD5File_16,
        tztZFMD5File_32,
        tztZFSHA256,
        tztZFSM3,

        tztZFBASE64,
        tztZFHEX,

        tztZFRC4,
        tztZFDES,
        tztZF3DES,
        tztZFAES,

        tztZFRSAPub,
        tztZFRSAPri,
        tztZFRSATempPub,
        tztZFRSATempPri,

        tztZFSM4,
        tztZFSM2,

        tztZFZip_Lz4HC,
        tztZFZip_Lz4
})

@Retention(RetentionPolicy.SOURCE)
public @interface tztZFEncryptType {
    int tztZFMD5_16 = (1);
    int tztZFMD5_32 = (2);
    int tztZFMD5File_16 = (3);
    int tztZFMD5File_32 = (4);
    int tztZFSHA256 = (5);
    int tztZFSM3 = (6);

    int tztZFBASE64 = (21);
    int tztZFHEX = (22);

    int tztZFRC4 = (51);
    int tztZFDES = (52);
    int tztZF3DES = (53);
    int tztZFAES = (54);

    int tztZFRSAPub = (81);
    int tztZFRSAPri = (82);
    int tztZFRSATempPub = (83);
    int tztZFRSATempPri = (84);

    int tztZFSM4 = (101);
    int tztZFSM2 = (102);

    int tztZFZip = (200);
    int tztZFZip_Lz4HC = (201);
    int tztZFZip_Lz4 = (202);
}
