package com.tztzf.protocol.define;

import static com.tztzf.protocol.define.tztZFHandshakeStatus.tztZFHandshake_Error;
import static com.tztzf.protocol.define.tztZFHandshakeStatus.tztZFHandshake_Failed;
import static com.tztzf.protocol.define.tztZFHandshakeStatus.tztZFHandshake_Handing;
import static com.tztzf.protocol.define.tztZFHandshakeStatus.tztZFHandshake_Init;
import static com.tztzf.protocol.define.tztZFHandshakeStatus.tztZFHandshake_Non;
import static com.tztzf.protocol.define.tztZFHandshakeStatus.tztZFHandshake_Rehand;
import static com.tztzf.protocol.define.tztZFHandshakeStatus.tztZFHandshake_Success;

import com.tztzf.baseos.tztZFIntDef;

import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

/**
 * 作者: yangdl 2019.06
 * 用途: 握手协商状态-同tztHandshake_Status
 * 修改记录如下:
 *
 * @版本号: 1.00.001 2019.06.10
 * 更新说明: 第一版正式发布
 */
@tztZFIntDef({
        tztZFHandshake_Non,
        tztZFHandshake_Init,
        tztZFHandshake_Handing,
        tztZFHandshake_Error,
        tztZFHandshake_Failed,
        tztZFHandshake_Rehand,
        tztZFHandshake_Success

})
@Retention(RetentionPolicy.SOURCE)

public @interface tztZFHandshakeStatus {
    int tztZFHandshake_Non = (0);
    int tztZFHandshake_Init = (1); //初始化
    int tztZFHandshake_Handing = (2);  //握手中
    int tztZFHandshake_Error = (3);    //握手错误
    int tztZFHandshake_Failed = (4);   //握手失败
    int tztZFHandshake_Rehand = (5);   //重新握手
    int tztZFHandshake_Success = (6);  //握手成功
}
