package com.tztzf.protocol.define;

import static com.tztzf.protocol.define.tztZFPackageType.tztZFPackage_AutoPush;
import static com.tztzf.protocol.define.tztZFPackageType.tztZFPackage_Data;
import static com.tztzf.protocol.define.tztZFPackageType.tztZFPackage_Handshake;
import static com.tztzf.protocol.define.tztZFPackageType.tztZFPackage_Non;
import static com.tztzf.protocol.define.tztZFPackageType.tztZFPackage_OnLine;
import static com.tztzf.protocol.define.tztZFPackageType.tztZFPackage_Socket;

import com.tztzf.baseos.tztZFIntDef;

import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

/**
 * 作者: yangdl 2019.06
 * 用途: 数据包类型-同tztZFPackageType
 * 修改记录如下:
 *
 * @版本号: 1.00.001 2019.06.10
 * 更新说明: 第一版正式发布
 */
@tztZFIntDef({
        tztZFPackage_Non,
        tztZFPackage_Data,
        tztZFPackage_OnLine,
        tztZFPackage_AutoPush,
        tztZFPackage_Handshake,
        tztZFPackage_Socket
})
@Retention(RetentionPolicy.SOURCE)
public @interface tztZFPackageType {
    int tztZFPackage_Non = (0);//空，未设置
    int tztZFPackage_Data = (1);//数据包
    int tztZFPackage_OnLine = (2);//心跳包
    int tztZFPackage_AutoPush = (3);//主推订阅包
    int tztZFPackage_Handshake = (4);//协议握手包
    int tztZFPackage_Socket = (5);//网络检测包
}
