package com.tztzf.protocol;

import com.tztzf.protocol.core.tztZFDataEncrypt;
import com.tztzf.protocol.define.tztZFEncryptType;
import com.tztzf.protocol.define.tztZFOperType;

/*
 * 作者: yangdl 2019.06
 * 用途: tztProtocol.so:NDK数据编解码处理
 * 修改记录如下:
 * 版本号: 1.00.001 2019.06.10
 * 更新说明: 第一版正式发布
 */
public class tztZFEncryptKit {
    //region 加解密
    //-------------------------

    //通用加解密接口
    public static byte[] encryptOper(@tztZFOperType int oper, @tztZFEncryptType int type, byte[] key, byte[] data) {
        return tztZFDataEncrypt.encryptOper(oper, type, key, data, 0);
    }

    //使用固定密钥加密资源数据
    public static byte[] encryptResource(byte[] srcData, int srcDataLen) {
        return tztZFDataEncrypt.encryptResource(srcData);
    }

    //使用固定密钥解密资源数据
    public static byte[] descryptResource(byte[] srcData, int srcDataLen) {
        return tztZFDataEncrypt.descryptResource(srcData);
    }

    //使用指定密钥加密数据
    public static byte[] encryptResource(byte[] key, int keylen, byte[] srcData, int srcDataLen) {
        return tztZFDataEncrypt.encryptResource(key, srcData);
    }

    //使用指定密钥解密数据
    public static byte[] descryptResource(byte[] key, int keylen, byte[] srcData, int datalen) {
        return tztZFDataEncrypt.descryptResource(key, srcData);
    }

    //使用rc4加密
    public static byte[] rc4Encrypt(byte[] key, int keylen, byte[] srcData, int srcDatalen) {
        return tztZFDataEncrypt.rc4Encrypt(key, srcData);
    }

    //使用rc4解密
    public static byte[] rc4Descrypt(byte[] key, int keylen, byte[] srcData, int srcDatalen) {
        return tztZFDataEncrypt.rc4Descrypt(key, srcData);
    }


    //MD5-16位
    public static byte[] encryptMD5_16(byte[] bytes, int len) {
        return tztZFDataEncrypt.encryptMD5_16(bytes);
    }

    //MD5-32位
    public static byte[] encryptMD5_32(byte[] bytes, int len) {
        return tztZFDataEncrypt.encryptMD5_32(bytes);
    }

    public static String encryptMD532Str(byte[] data) {
        return tztZFDataEncrypt.encryptMD532Str(data);
    }

    //Base64 Encrypt
    public static byte[] encryptBase64(byte[] bytes, int len) {
        return tztZFDataEncrypt.encryptBase64(bytes);
    }

    public static String encryptBase64Str(byte[] bytes) {
        return tztZFDataEncrypt.encryptBase64Str(bytes);
    }

    //Base64 Decrypt
    public static byte[] decryptBase64(byte[] bytes, int len) {
        return tztZFDataEncrypt.decryptBase64(bytes);
    }

    public static byte[] decryptBase64Str(String base64) {
        if (base64 == null || base64.length() < 1)
            return null;
        byte[] cBase = base64.getBytes();
        return tztZFDataEncrypt.decryptBase64(cBase);
    }

    public static byte[] sm4Encrypt(byte[] data, int dataLen, byte[] key, int keyLen) {
        return tztZFDataEncrypt.sm4Encrypt(data, key);
    }

    public static byte[] sm4Decrypt(byte[] data, int dataLen, byte[] key, int keyLen) {
        return tztZFDataEncrypt.sm4Decrypt(data, key);
    }

    public static byte[] hexEncrypt(byte[] data, int dataLen) {
        return tztZFDataEncrypt.hexEncrypt(data);
    }

    public static byte[] hexDecrypt(byte[] data, int dataLen) {
        return tztZFDataEncrypt.hexDecrypt(data);
    }


    //SDK认证使用
    public static byte[] encryptDataWithCert(byte[] bytes, int userID, int linkType) {
        if (bytes == null)
            return null;
        return tztZFDataEncrypt.encryptDataWithCert(bytes, userID, linkType);
    }

    public static byte[] decryptDataWithCert(byte[] bytes, int userID, int linkType) {
        if (bytes == null)
            return null;
        return tztZFDataEncrypt.decryptDataWithCert(bytes, userID, linkType);
    }

    public static byte[] signDataWithCert(byte[] data, int userID, int linkType) {
        if (data == null)
            return null;
        return tztZFDataEncrypt.signDataWithCert(data, userID, linkType);
    }

    public static byte[] encryptRSA(long Exponent, byte[] modulus, byte[] srcData) {
        if (srcData == null || modulus == null)
            return null;
        return tztZFDataEncrypt.encryptRSA(Exponent, modulus, srcData);
    }

    public static int tztSM2_verify(byte[] cert, byte[] org, byte[] sign) {
        if (cert == null || cert.length < 1 || org == null || org.length < 1 || sign == null || sign.length < 1)
            return 0;
        return tztZFDataEncrypt.tztSM2_verify(cert, org, sign);
    }

    public static int tztSM2_verify(byte[] cert, byte[] org, byte[] kx, byte[] ky) {
        if (cert == null || cert.length < 1 || org == null || org.length < 1 || kx == null || kx.length < 1 || ky == null || ky.length < 1)
            return 0;
        return tztZFDataEncrypt.tztSM2_verify(cert, org, kx, ky);
    }
    //endregion

}
