package com.tztzf.protocol.tztnative;

import com.tztzf.soloader.tztZFSoLoader;

/**
 * 作者: yangdl 2019.06
 * 用途: tztProtocol.so:NDK数据编解码处理
 * 修改记录如下:
 *
 * @版本号: 1.00.001 2019.06.10
 * 更新说明: 第一版正式发布
 */

public class tztNativeCosignSSL {

    private static tztNativeCosignSSL cosignZZKit = new tztNativeCosignSSL();

    private static byte[] byteseNull = null;

    static {
        tztZFSoLoader.loadLibrary("tztZFProtocol");
//        System.loadLibrary("tztZFProtocol");
    }

    private static tztNativeCosignSSL getShareInstance() {
        if (cosignZZKit == null)
            cosignZZKit = new tztNativeCosignSSL();
        return cosignZZKit;
    }

    private static int getlen(byte[] data) {
        if (data != null)
            return data.length;
        return 0;
    }

    public static void loadCosignSSLFun() {
        getShareInstance().loadCosignSSLFunNative();
    }

    public static void unloadCosignSSLFun() {
        getShareInstance().unloadCosignSSLFunNative();
    }

    public static byte[] cosignInit() {
        return getShareInstance().cosignInitNative();
    }

    public static byte[] cosignStep1() {
        return getShareInstance().cosignStep1Native();
    }

    public static byte[] cosignStep3(byte[] clientKey,
                                     byte[] k1,
                                     byte[] r,
                                     byte[] s2,
                                     byte[] s3) {
        return getShareInstance().cosignStep3Native(clientKey, getlen(clientKey),
                k1, getlen(k1),
                r, getlen(r),
                s2, getlen(s2),
                s3, getlen(s3));
    }

    public static byte[] createPKCS10String(byte[] pub,
                                            byte[] sub,
                                            byte[] pin) {
        return getShareInstance().createPKCS10StringNative(pub, getlen(pub), sub, getlen(sub), pin, getlen(pin));
    }

    public static byte[] tztZF_i2d_ECDSA_SIG(int sigtype, byte[] sig) {
        byte[] sign = getShareInstance().tztZFECDSASIGNative(sigtype, sig, getlen(sig));
        return sign;
    }

    public static int tztZFSM2_verify(int certtype, byte[] cert, byte[] dgst, byte[] sig) {
        return getShareInstance().tztZFSM2verifyNative(certtype, cert, getlen(cert), dgst, getlen(dgst), sig, getlen(sig));
    }

    public static int tztZFSM2_verifyXY(int certtype, byte[] cert, byte[] dgst, byte[] kx, byte[] ky) {
        return getShareInstance().tztZFSM2verifyXYNative(certtype,
                cert, getlen(cert),
                dgst, getlen(dgst),
                kx, getlen(kx),
                ky, getlen(ky));
    }

    public static byte[] rand(int type, int len, byte[] seed) {
        return getShareInstance().randNative(type, len, seed, getlen(seed));
    }
    //endregion

    //region NDK 函数
//------------------------------NDK 函数----------------------//
    private native int loadCosignSSLFunNative();

    private native int unloadCosignSSLFunNative();

    private native byte[] cosignInitNative();

    private native byte[] cosignStep1Native();

    private native byte[] cosignStep3Native(byte[] clientKey, int clientKeylen,
                                            byte[] k1, int k1len,
                                            byte[] r, int rlen,
                                            byte[] s2, int s2len,
                                            byte[] s3, int s3len);

    private native byte[] createPKCS10StringNative(byte[] pub, int publen,
                                                   byte[] sub, int sublen,
                                                   byte[] pin, int pinlen);

    private native byte[] tztZFECDSASIGNative(int sigtype, byte[] sig, int siglen);

    private native int tztZFSM2verifyNative(int certtype, byte[] cert, int certlen, byte[] dgst, int dgstlen, byte[] sig, int siglen);

    private native int tztZFSM2verifyXYNative(int certtype, byte[] cert, int certlen, byte[] dgst, int dgstlen, byte[] kx, int kxlen, byte[] ky, int kylen);

    private native byte[] randNative(int type, int len, byte[] seed, int seedlen);
    //endregion
}
