package com.tztzf.protocol.tztnative;

import com.tztzf.soloader.tztZFSoLoader;

/**
 * 作者: yangdl 2019.06
 * 用途: tztProtocol.so:NDK数据编解码处理
 * 修改记录如下:
 *
 * @版本号: 1.00.001 2019.06.10
 * 更新说明: 第一版正式发布
 */

public class tztNativeEncryptFun {

    private static tztNativeEncryptFun encryptKit = new tztNativeEncryptFun();

    private static byte[] byteseNull = null;

    static {
        tztZFSoLoader.loadLibrary("tztZFProtocol");
//        System.loadLibrary("tztZFProtocol");
    }

    private static tztNativeEncryptFun getShareInstance() {
        if (encryptKit == null)
            encryptKit = new tztNativeEncryptFun();
        return encryptKit;
    }

    private static int getlen(byte[] data) {
        if (data != null)
            return data.length;
        return 0;
    }

    public static byte[] encryptOper(int oper, int type, byte[] key, byte[] data, int len) {
        return getShareInstance().encryptOperNative(oper, type, key, getlen(key), data, getlen(data), len);
    }

    public static byte[] tztZFGetRandom(int bits) {
        return getShareInstance().tztZFGetRandomNative(bits);
    }

    public static byte[] tztMakeTempRSA(int bits) {
        return getShareInstance().tztMakeTempRSANative(bits);
    }

    public static byte[] tztGetAjaxRC4Key() {
        return getShareInstance().tztGetAjaxRC4KeyNative();
    }

    //RSA
    public static byte[] encryptRSA(long exponent, byte[] key, byte[] data) {
        return getShareInstance().encryptRSANative(exponent, key, getlen(key), data, getlen(data));
    }
    //endregion


    //region NDK 函数
//------------------------------NDK 函数----------------------//
    //创建dataobj
    private native byte[] encryptOperNative(int oper, int type, byte[] key, int keylen, byte[] data, int datalen, int len);

    private native byte[] tztZFGetRandomNative(int bits);

    private native byte[] tztMakeTempRSANative(int bits);

    private native byte[] tztGetAjaxRC4KeyNative();

    //ras
    private native byte[] encryptRSANative(long exponent, byte[] key, int keylen, byte[] data, int datalen);
    //endregion
}
